(function ($) {
    var done = false;

    $('input.select-all').on('change', function(e){
        var selector = $(this).data('select_selector');

        $(selector).prop('checked', $(this).is(':checked'));
    });

    function run_import(first_run = false) {
        if(done){
            $('#rlstatus').text('DONE!');
            $('#rlimportcontrol').text('Run Another Import');
            return;
        }

        $.post(ajaxurl, {
            'action': 'rl_import_process',
            'run': (first_run ? 'no' : 'yes')
        }, function (data) {
            var elapsed_time_total = data.current_time - data.start_time;

            var elapsed_time_minutes = Math.floor(elapsed_time_total / 60);
            var elapsed_time_seconds = elapsed_time_total - (elapsed_time_minutes * 60);

            var elapsed_time_hours = Math.floor(elapsed_time_total / (60 * 60));
            var elapsed_time_minutes = Math.floor((elapsed_time_total - (elapsed_time_hours * 60 * 60)) / 60);
            var elapsed_time_seconds = elapsed_time_total - (elapsed_time_minutes * 60) - (elapsed_time_hours * 60 * 60);

            var expected_time_per_task = elapsed_time_total / data.completed;
            var expected_time_left = Math.ceil(expected_time_per_task * (data.total - data.completed));

            var expected_time_left_hours = Math.floor(expected_time_left / (60 * 60));
            var expected_time_left_minutes = Math.floor((expected_time_left - (expected_time_left_hours * 60 * 60)) / 60);
            var expected_time_left_seconds = expected_time_left - (expected_time_left_minutes * 60) - (expected_time_left_hours * 60 * 60);

            $('#rlprogress').attr('max', data.total).attr('value', data.completed);
            $('#rllog').html(data.messages);

            if (data.completed >= data.total) {
                $('#rlstatus').text('DONE!');
                $('#rlimportcontrol').text('Run Another Import');
                done = true;
            } else {
                $('#rlstatus').text(data.completed + ' of ' + data.total + ' task completed over ' + elapsed_time_hours + ' hours and ' + elapsed_time_minutes + ' minutes and ' + elapsed_time_seconds + ' seconds. Expected time left is ' + expected_time_left_hours + ' hours and ' + expected_time_left_minutes + ' minutes and ' + expected_time_left_seconds + ' seconds.');
            }
        }).fail(function () {
            $('#rlstatus').text('Unknown Error. Running Again...');
        }).always(function () {
            setTimeout(function(){
                run_import();
            }, 500);
        });
    }

    if ($('#rlprogress').length == 1) {
        run_import(true);
    }
})(jQuery);