<?php

namespace Rapidline;

class API {

    private $api_key = null;

    public function __construct($api_key){
        $this->api_key = $api_key;
    }

    public function ping(){
        $response = $this->request('ping');

        return $response;
    }

    public function category($category_id){
        $response = $this->request('category', [
            'category_id' => $category_id
        ]);

        return $response;
    }

    public function categories($parent_id = null){
        $request_data = array();

        if($parent_id !== null){
            $request_data['parent_id'] = $parent_id;
        }

        $response = $this->request('categories', $request_data);

        return $response;
    }

    public function product($product_id){
        $response = $this->request('product', [
            'product_id' => $product_id
        ]);

        return $response;
    }

    public function products($category_id = null){
        $request_data = array();

        if($category_id !== null){
            $request_data['category_id'] = $category_id;
        }

        $response = $this->request('products', $request_data);

        return $response;
    }

    public function request($action, $request_data = array()){
        $request_data['action'] = 'api_'.$action;

        $url = 'https://rapidline.com.au/wp-admin/admin-ajax.php';

        if(count($request_data)){
            $url .= '?'.http_build_query($request_data);
        }

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'X-API-KEY: '.$this->api_key,
        ));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $response_string = curl_exec($ch);
        
        $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        curl_close($ch);

        if($http_code == '200'){
            return json_decode($response_string, true);
        }

        return false;
    }
}