<?php
/**
 * Plugin Name: Rapidline Products Importer for WooCommerce
 * Description: Import RapidLine Products in to WooCommerce from the Rapidline Catalogue API
 * Version: 1.0.10
 * Author: F8 Media
 * Author URI: https://f8media.com.au
*/

require_once 'vendor/autoload.php';
require_once 'functions.php';

define('RL_IMPORTER_VERSION', '1.0.10');
define('RL_IMPORTER_SLUG', plugin_basename( __DIR__ ));
define('RL_IMPORTER_BASE_PATH', dirname(__FILE__));
define('RL_IMPORTER_BASE_URL', plugin_dir_url(__FILE__));
define('RL_IMPORTER_COLOURS_ATTRIBUTE', 'Colours');

$rl_core = new \RL\Core();

$rl_cron = new \RL\Cron();

$rl_updates = new \RL\Admin\Updates('rapidline/woocommerce-rapidline', RL_IMPORTER_SLUG, RL_IMPORTER_VERSION, false);

register_deactivation_hook(__FILE__, 'rl_deactivate');

function rl_deactivate(){
	global $rl_updates, $rl_cron;

	$rl_updates->deactivate();
	$rl_cron->deactivate();
}